'Coded by UEZ build 2020-12-23
'Thanks to:	dodicat for some functions I used from his codes :-) 
'		   	Joshy for the ImageScale and CreateBall function. ^^
'		   	CyberZip of Tidal for the tune.
'		   	https://www.pngegg.com for the images.
'			Firelight Technologies Pty Ltd for fmod DLL
'			Oscar for the German poem (scroller text)

#Include "file.bi"
#Include "fbgfx.bi"

Dim Shared as boolean bSound = False
Dim As Any Ptr hLib

#Ifdef __Fb_win32__
	Dim Shared FSOUND_Init As Function(Byval As Integer, Byval As Integer, Byval As Uinteger) As Byte
	Dim Shared FMUSIC_LoadSong As Function(Byval As Zstring Ptr) As Any Ptr
	Dim Shared FMUSIC_PlaySong As Function(Byval As Any Ptr) As Byte
	Dim Shared FMUSIC_FreeSong As Function(Byval As Any Ptr) As Byte
	Dim Shared FMUSIC_SetMasterVolume As Function(Byval As Any Ptr, As Integer) As Byte
	Dim Shared FSOUND_Close As Sub()
		
	bSound = True
	#Ifdef __Fb_64bit__
		If Fileexists(Curdir & "/Sound/fmod64.dll") = 0 Then
			bSound = False
		Else
			hLib = Dylibload(Curdir & "/Sound/fmod64.dll")
			FSOUND_Init = Dylibsymbol(hLib, "FSOUND_Init")
			FMUSIC_LoadSong = Dylibsymbol(hLib, "FMUSIC_LoadSong")
			FMUSIC_PlaySong = Dylibsymbol(hLib, "FMUSIC_PlaySong")
			FMUSIC_FreeSong = Dylibsymbol(hLib, "FMUSIC_FreeSong")
			FMUSIC_SetMasterVolume = Dylibsymbol(hLib, "FMUSIC_SetMasterVolume")
			FSOUND_Close = Dylibsymbol(hLib, "FSOUND_Close")
		Endif
	#Else
		If Fileexists(Curdir & "/Sound/fmod.dll") = 0 Then
			bSound = False
		Else
			hLib = Dylibload(Curdir & "/Sound/fmod.dll")
			FSOUND_Init = Dylibsymbol(hLib, "_FSOUND_Init@12")
			FMUSIC_LoadSong = Dylibsymbol(hLib, "_FMUSIC_LoadSong@4")
			FMUSIC_PlaySong = Dylibsymbol(hLib, "_FMUSIC_PlaySong@4")
			FMUSIC_FreeSong = Dylibsymbol(hLib, "_FMUSIC_FreeSong@4")
			FMUSIC_SetMasterVolume = Dylibsymbol(hLib, "_FMUSIC_SetMasterVolume@8")
			FSOUND_Close = Dylibsymbol(hLib, "_FSOUND_Close@0")
		Endif
	#Endif
#Else
	#include "fmod.bi" 'only x86 support
#Endif


Using FB

#Define Map(Val, source_start, source_stop, dest_start, dest_stop)	((Val - source_start) * (dest_stop - dest_start) / (source_stop - source_start) + dest_start)
#Define Round(x)                                             		((x + 0.5) Shr 0)
#Define Max(a, b)													(Iif(a > b, a, b))
#Define Min(a, b)													(Iif(a < b, a, b))

Dim As String sWintitle = "3D animated Christmas Tree coded by UEZ build 2020-12-23"

Const w = 1200, h = 800, w2 = w \ 2, h2 = h \ 2, pi = Acos(-1), pi2 = Acos(-1) / 2
Const radians = pi / 180, deg = 180 / pi

Union _Color
	As Ulong argb
	Type
		As Ubyte b, g, r, a
	End Type
End Union

Type vec3
	As Single x, y, z
End Type

Type vec5
	As Ubyte s
	As Single x, y, vx, vy
End Type

Type vec9
	As Boolean bTrunk, bStar, bRibbon
	As UByte iBall
	As Single x, y, z
	As _Color col
End Type

Dim Shared As Const vec3 EyePoint = Type(w2, h2, h)


'Taylor series
'Sum n = 0 To inf (-1)^n * x^(2n) / (2n)! = 1 - x^2 / 2! + x^4 / 4! -x^6 / 6! + ...
Function Cos_(x As Single) As Single
    If x < 0 Then x = -x
    While x >= 3.141592653589793 'pi
        x -= 6.283185307179586 '2 * pi
    Wend
   Dim As Single xx = x * x
    Return 1.0 - (xx / 2) * (1 - (xx / 12) * (1 - (xx / 30) * (1 - xx / 56))) 'approximation of Taylor serie
End Function

Function Sin_(x As Single) As Single
    Return Cos_(x - 1.570796326794897) 'pi / 2
End Function

Function ImageScale(s As Image Ptr, Scale as single=1.0) As Image Ptr 'by Joshy
	Static As Image Ptr t=0
	If s        =0 Then Return 0
	If s->width <1 Then Return 0
	If s->height<1 Then Return 0
	scale=abs(scale)
	dim as integer _w = s->width *Scale
	dim as integer _h = s->height*Scale
	If _w<4 Then _w=4
	If _h<4 Then _h=4
	if t then ImageDestroy(t) : t=0
	t=ImageCreate(_w,_h)
	Dim As Integer xs=(s->width /t->Width ) * (1024*64)
	Dim As Integer ys=(s->height/t->height) * (1024*64)
	Dim As Integer x,y,sy
	Select Case As Const s->bpp
		Case 4
			Dim As Ulong Ptr ps=cptr(Ulong Ptr,s)+8
			Dim As Uinteger  sp=(s->pitch Shr 2)
			Dim As Ulong Ptr pt=cptr(Ulong Ptr,t)+8
			Dim As Uinteger  tp=(t->pitch Shr 2)-t->width
			For ty As Integer = 0 To t->height-1
				Dim As Ulong Ptr src=ps+(sy Shr 16)*sp
				For tx As Integer = 0 To t->width-1
					*pt=src[x Shr 16]:pt+=1:x+=xs
				Next
				pt+=tp:sy+=ys:x=0
			Next
		Case 2
			Dim As Ushort Ptr ps=cptr(Ushort Ptr,s)+16
			Dim As Uinteger   sp=(s->pitch Shr 1)
			Dim As Ushort Ptr pt=cptr(Ushort Ptr,t)+16
			Dim As Uinteger   tp=(t->pitch Shr 1)-t->width
			For ty As Integer = 0 To t->height-1
				Dim As Ushort Ptr src=ps+(sy Shr 16)*sp
				For tx As Integer = 0 To t->width-1
					*pt=src[x Shr 16]:pt+=1:x+=xs
				Next
				pt+=tp:sy+=ys:x=0
			Next
		Case 1
			Dim As Ubyte Ptr ps=cptr(Ubyte Ptr,s)+32
			Dim As Uinteger  sp=s->pitch
			Dim As Ubyte Ptr pt=cptr(Ubyte Ptr,t)+32
			Dim As Uinteger  tp=t->pitch-t->width
			For ty As Integer = 0 To t->height-1
			Dim As Ubyte Ptr src=ps+(sy Shr 16)*sp
			For tx As Integer = 0 To t->width-1
				*pt=src[x Shr 16]:pt+=1:x+=xs
			Next
			pt+=tp:sy+=ys:x=0
			Next
	End Select
	Return t
End Function

Sub Object3Dto2D(wa() As vec9, result() As vec9, angle As vec3, centre As vec3, rad As Single = 1.0, flag As Boolean = True) 'by dodicat
   Dim As Single dx,dy,dz,ww
   Dim As Single SinAX=Sin_(angle.x)
   Dim As Single SinAY=Sin_(angle.y)
   Dim As Single SinAZ=Sin_(angle.z)
   Dim As Single CosAX=Cos_(angle.x)
   Dim As Single CosAY=Cos_(angle.y)
   Dim As Single CosAZ=Cos_(angle.z)
   
   For z As Uinteger=Lbound(wa) To Ubound(wa)
      dx=wa(z).x-centre.x
      dy=wa(z).y-centre.y
      dz=wa(z).z-centre.z
      Result(z).x=rad*((Cosay*Cosaz)*dx+(-Cosax*Sinaz+Sinax*Sinay*Cosaz)*dy+(Sinax*Sinaz+Cosax*Sinay*Cosaz)*dz)+centre.x
      result(z).y=rad*((Cosay*Sinaz)*dx+(Cosax*Cosaz+Sinax*Sinay*Sinaz)*dy+(-Sinax*Cosaz+Cosax*Sinay*Sinaz)*dz)+centre.y
      result(z).z=rad*((-Sinay)*dx+(Sinax*Cosay)*dy+(Cosax*Cosay)*dz)+centre.z

      If flag Then
         ww = 1 + (result(z).z/EyePoint.z)
         result(z).x = (result(z).x-EyePoint.x)/ww+EyePoint.x
         result(z).y = (result(z).y-EyePoint.y)/ww+EyePoint.y
         result(z).z = (result(z).z-EyePoint.z)/ww+EyePoint.z
      Endif
	  result(z).col=wa(z).col
      result(z).bTrunk = wa(z).bTrunk
      result(z).bRibbon = wa(z).bRibbon
      result(z).iBall = wa(z).iBall
      result(z).bStar = wa(z).bStar
   Next z
End Sub

Sub QsortZ(array() As vec9, begin As Integer, Finish As Uinteger) 'by dodicat
    Dim As Integer i = begin, j = finish
    Dim As vec9 X = array(((I + J) \ 2))
    While I <= J
        While array(I).z > X .z : I += 1 : Wend
        While array(J).z < X .z : J -= 1 : Wend
        If I <= J Then Swap array(I), array(J) : I += 1 : J -= 1
   Wend
   If J > begin Then QsortZ(array(), begin, J)
   If I < Finish Then QsortZ(array(), I, Finish)
End Sub

Function Regulate(TargetFPS As Long, Byref fps As Long) As Long 'by dodicat
	Static As Double timervalue, _lastsleeptime, t3, frames
	Var t = Timer
	frames += 1
	If (t - t3) >= 1 Then t3 = t : fps = frames : frames = 0
	Var sleeptime =_lastsleeptime + ((1 / TargetFPS) - t + timervalue) * 1000
	If sleeptime < 1 Then sleeptime = 1
	_lastsleeptime = sleeptime
	timervalue = t
	Return sleeptime
End Function

Sub CreateBall(radius As Ulong, col As Ulong, pImage As Image Ptr) 'by Joshy
	Dim As Ulong r = radius, size = radius * 2
	Dim As Single be = col And &hFF, blue = be / 4
	col Shr = 8
	Dim As Single ge = col And &hFF, green= ge / 4
	col Shr = 8
	Dim As Single re = col And &hFF, red  = re / 4
	col Shr = 8
	Dim As Single ae = col And &hFF, alpha = ae / 4
	
	Dim As Single f = r / 3, rs = red / f, gs = green / f, bs = blue / f, als = alpha / f
	  
	While r
		r -= 1
		Circle pImage, (radius, radius), r, Rgba(red, green, blue, 255 - r),,,, F
		red += rs
		green += gs
		blue += bs
		'alpha += als
	Wend	
End Sub

Screenres w, h, 32, 2, GFX_WINDOWED Or GFX_NO_SWITCH Or GFX_ALPHA_PRIMITIVES 'Or GFX_ALWAYS_ON_TOP
Screenset 1, 0

Dim As Ulong particles = 10000, i, j = 35, k, l, ub
Dim As Single x, y, ang, zoom = 1.0
Dim As Ulong iCol, iCounter = 0
Dim As vec9 aParticles(particles - 1), aResult(particles - 1)

Dim As Ulong radius = 11, r = radius, size = radius * 2
Dim As Image Ptr aBalls(1 To 4)
aBalls(1) = Imagecreate(size, size, 0, 32)
aBalls(2) = Imagecreate(size, size, 0, 32)
aBalls(3) = Imagecreate(size, size, 0, 32)
aBalls(4) = Imagecreate(size, size, 0, 32)
CreateBall(radius, Rgba(&hF7, &h0D, &h1A, &hFF), aBalls(1)) 'red
CreateBall(radius, Rgba(&hFD, &hD0, &h17, &hFF), aBalls(2)) 'gold
CreateBall(radius, Rgba(&h1F, &h45, &hFC, &hFF), aBalls(3)) 'blue
CreateBall(radius, Rgba(&h8D, &h38, &hC9, &hFF), aBalls(4)) 'purple

Randomize

'Stamm
For i = 1 To 105
	If Rnd() > 0.10 Then 
		aParticles(iCounter).x = w2 + Rnd() * 2 - 1
		aParticles(iCounter).y = -250 + h2 + i * 4.75
		aParticles(iCounter).z = Rnd() * 5 - 10
		aParticles(iCounter).bTrunk = True
		aParticles(iCounter).col.argb = Rgba(&h49 + Rnd() * 10 - 5, &h3D + Rnd() * 10 - 5, &h26 + Rnd() * 10 - 5, 255)
		iCounter += 1
	Endif
Next

Dim As Single parts = 10, angle2, maxx, minx, maxz, minz, angle

'ste und Kugel
For l = 1 To 29
	angle = Rnd() * 360 * radians
	For k = 1 To parts
		angle += (360 / parts + Rnd() * 15 - 7.5) * radians
		For i = 3 To Sqr(j)
			If Rnd() > 0.3333 Then 
				aParticles(iCounter).x = w2 - i^1.675 * Cos(angle) + Rnd() * 10 - 5
				aParticles(iCounter).z = i^1.675 * Sin(angle) + Rnd() * 10 - 5			
				aParticles(iCounter).y = -25 + aParticles(0).y + aParticles(iCounter).y + j + Rnd() * 8 - 4
				If iCounter > 0 Then
					minx = Min(aParticles(iCounter).x, aParticles(iCounter - 1).x)
					maxx = Max(aParticles(iCounter).x, aParticles(iCounter - 1).x)
					minz = Min(aParticles(iCounter).z, aParticles(iCounter - 1).z)
					maxz = Max(aParticles(iCounter).z, aParticles(iCounter - 1).z)
				End If
				iCounter += 1
			Endif
		Next
		If Rnd() > 0.49 Then 'Kugel
			aParticles(iCounter).x = Iif(Rnd() < 0.5, minx - 1, maxx + 1)
			aParticles(iCounter).z = Iif(Rnd() < 0.5, minz - 1, maxz + 1)
			aParticles(iCounter).y = aParticles(iCounter - 1).y + Rnd() * 8 + 1
			aParticles(iCounter).iBall = Lbound(aBalls) + Cubyte(Rnd() * (Ubound(aBalls) - 1))
			iCounter += 1					
		End If
	Next
	j += 15
Next

'das rote Band
angle = Rnd() * 360 * radians
For i = 1 To 400 Step 1
	aParticles(iCounter).x = w2 - i ^ 0.85 * Cos(angle)
	aParticles(iCounter).y = aParticles(0).y + i 
	aParticles(iCounter).z = i ^ 0.85 * Sin(angle)
	aParticles(iCounter).bRibbon = True
	aParticles(iCounter).col.argb = &hFFF62817 
	angle += (360 / 100) * radians
	iCounter += 1
Next

'Stern by dodicat
Var count = 0, rad = 0.0, size2 = 15, s2 = 5
For z As Single = -pi - 0.3 To 2 * pi Step 2 * pi / 10
	count += 1
	If count Mod 2 = 0 Then 
		rad = size2 
	Else 
		rad = 0.4 * size2
	Endif
	aParticles(iCounter).x = aParticles(0).x + rad * Cos_(z)
	aParticles(iCounter).y = aParticles(0).y - size2 - s2 + rad * Sin_(z)
	aParticles(iCounter).z = aParticles(0).z
	aParticles(iCounter).bStar = True
	aParticles(iCounter).col.argb = &hFFFDD017
	iCounter += 1
Next z

Redim Preserve aParticles(iCounter - 1)
Redim Preserve aResult(iCounter - 1)
ub = Ubound(aParticles)

Windowtitle(sWintitle)

Dim As Image Ptr pImageLeaf = Imagecreate(64, 64, 0, 32), pImageText = Imagecreate(655, 234, 0, 32), pImageGift = Imagecreate(400, 184, 0, 32), _
				 pImageSnowman = Imagecreate(188, 300, 0, 32), pImageOlaf = Imagecreate(228, 300, 0, 32), pImageScaled
Bload Curdir & "/Images/Leaf4.1.bmp", pImageLeaf
Bload Curdir & "/Images/Merry Christmas_655x234.bmp", pImageText
Bload Curdir & "/Images/Assorted-color gift box lot illustration_400x184.bmp", pImageGift
Bload Curdir & "/Images/Santa Claus Christmas decoration Snowman_188x300.bmp", pImageSnowman
Bload Curdir & "/Images/Olaf_228x300.bmp", pImageOlaf

Dim As String sScrollerText = "Denkt euch, ich habe 'Corona' geseh'n, sie kam aus dem Osten und blieb dort nicht steh'n. " & _ 
							  "Sie fegte hinueber zum Tannenwald und machte auf ihrem Weg auch dort nicht halt. Sie brachte Krankheit, Tod und Isolation ueber unsere gesamte Nation. " & _
							  "Arbeit, Freizeit und Urlaub in diesem Jahr nichts ist, wie es frueher mal war. Wir halten nun Abstand und hamstern was geht, mit Klorolle und Maske, " & _
							  "die Welt sich doch dreht. Das Weihnachtsfest bescheiden und klein, bei gutem Essen und einem Glas Wein. Sylvester wird's wohl auch nicht so bunt! Von Oscar"
Dim As Ulong iFPS, s1, iSnow = 750, iSizeSnow = 2
Dim As Uinteger dh = h * 0.66
Dim as Single f, lt = Len(sScrollerText) * 11, px = w, py, st = -1, th = dh - 7, a

Dim As vec5 aSnow(1 To iSnow)
For i = 1 To iSnow
	aSnow(i).x = Rnd() * (w - 1)
	aSnow(i).y = Rnd() * -h
	aSnow(i).vx = Rnd() * 2 - 1
	aSnow(i).vy = 1 + Rnd() * 3
	aSnow(i).s = aSnow(i).vy
Next

#Macro LetItSnow(ss, ee)
	For i = ss To ee
		a = &hF0 - aSnow(i).s * aSnow(i).s * 5
		Circle (aSnow(i).x, aSnow(i).y), aSnow(i).s, Rgba(255, 255, 255, a),,,, F
		Circle (aSnow(i).x, aSnow(i).y), aSnow(i).s, Rgba(&hA0, &hA0, &hB0, a)
		aSnow(i).x += aSnow(i).vx * Sin_(ang * 4) * 2
		aSnow(i).y += aSnow(i).vy
		
		If aSnow(i).x > w + 3 Then aSnow(i).x = 0
		If aSnow(i).x < -3 Then aSnow(i).x = w
		
		If aSnow(i).y > h Then
			aSnow(i).x = 1 + Rnd() * (w - 2)
			aSnow(i).y = 0
			aSnow(i).vx = Rnd() * 2 - 1
			aSnow(i).vy = 1 + Rnd() * 3
			aSnow(i).s = aSnow(i).vy
		End If
	Next
#Endmacro

Dim As any Ptr pSong
If bSound Then
	FSOUND_Init(44100, 32, 0)
	pSong = FMUSIC_LoadSong(Curdir & "/Sound/christmas_remix_96.xm")
	FMUSIC_SetMasterVolume(pSong, Map(33, 0, 100, 0, 256)) '0 - 100% will be mapped to 0 - 256
	FMUSIC_PlaySong(pSong)
Endif

Dim As Double fTimer = Timer

Do
	Line (0, 0) - (w - 1, dh), &hF0F0F0F0, BF
	For i = dh + 1 To h - 1
		f = Map(i, dh + 1, h - 1, &hC0, &hFF)
		Line (0, i) - (w - 1, i), Rgb(f, f, f)
	Next
	Put ((w - 655) \ 2, 50), pImageText, Alpha
	
	py = 2.7^(-4 + Sin_(-ang * 5) * 3.5) * Abs(Cos_(ang * 100))   'scroller boucing formular
	Draw String(px, th - py * 50), sScrollerText, &hE0000000
	px += st
	If px < -lt Then px = w
	
	LetItSnow(1, iSnow Shr 1)
	
	ang += .0020
	Object3Dto2D(aParticles(), aResult(), Type<vec3>(0, -2 * ang, 0), Type<vec3>(w2, h2, 0), zoom)
	'Object3Dto2D(aParticles(), aResult(), Type<vec3>(pi / 2, 0, ang), Type<vec3>(w2, h2, 0), zoom) 'top view of tree
	Qsortz(aResult(), 0, ub)

	For i = 0 To ub
		If aResult(i).z < 200 Then
			If aResult(i).bTrunk Then 
				s1 = Map(aResult(i).y, -120, h2, 1, 10)
				Circle (aResult(i).x, aResult(i).y), s1, aResult(i).col.argb,,,, F
			Elseif aResult(i).bStar Then
				s2 = 5
				Circle (aResult(i).x, aResult(i).y), s2, aResult(i).col.argb,,,, F
				aResult(i).col.a \= 3
				aResult(i).col.r Shr= 1
				aResult(i).col.g Shr= 1
				aResult(i).col.b Shr= 1
				Circle (aResult(i).x, aResult(i).y), s2, aResult(i).col.argb
			Elseif aResult(i).bRibbon Then 
				s2 = map(aResult(i).z, -800, 0, 25, 10)
				Line (aResult(i).x, aResult(i).y) - (aResult(i).x + s2, aResult(i).y + s2), aResult(i).col.argb, BF
				aResult(i).col.a Shr= 2
				aResult(i).col.r Shr= 1
				aResult(i).col.g Shr= 1
				aResult(i).col.b Shr= 1				
				Line (aResult(i).x, aResult(i).y) - (aResult(i).x + s2, aResult(i).y), aResult(i).col.argb
				Line (aResult(i).x, aResult(i).y + s2) - (aResult(i).x + s2, aResult(i).y + s2), aResult(i).col.argb
				'Circle (aResult(i).x, aResult(i).y), s2, aResult(i).col.argb,,,, F
			Elseif aResult(i).iBall Then
				Put (aResult(i).x - radius, aResult(i).y - radius), aBalls(aResult(i).iBall), Alpha
			Else
				f = map(aResult(i).z, -1200, 0, 2.5, 0.35)
				pImageScaled = ImageScale(pImageLeaf, f)
				Put (aResult(i).x - f * 32, aResult(i).y - f * 16), pImageScaled, Alpha
			Endif
		Endif
	Next
	
	Put (w2 - 200, h2 + 200), pImageGift, Alpha
	Put (100, h2), pImageSnowman, Alpha
	Put (w2 + 300, h2), pImageOlaf, Alpha
	
	LetItSnow(iSnow Shr 1 + 1, iSnow)
	
	Draw String(1, 1), iFPS & " fps", &hFF000000

	Flip

	Sleep(Regulate(60, iFPS), 1)
Loop Until Len(Inkey())

For i = Lbound(aBalls) To Ubound(aBalls)
	Imagedestroy(aBalls(i))
Next
Imagedestroy(pImageText)
Imagedestroy(pImageScaled)
Imagedestroy(pImageLeaf)
Imagedestroy(pImageGift)
Imagedestroy(pImageSnowman)
Imagedestroy(pImageOlaf)
If bSound Then
	FMUSIC_FreeSong(pSong)
	FSOUND_Close()
Endif